require 'fileutils'
require 'json'
require 'highline'
require 'digest'
require 'active_support/hash_with_indifferent_access'
require 'uqam_grade_notification/version'
require 'uqam_grade_notification/student'
require 'uqam_grade_notification/notifier'
require 'uqam_grade_notification/client'
require 'uqam_grade_notification/storage'

module UqamGradeNotification
  APP_DIR = "#{ENV["HOME"]}/.uqam_grade_notification"
  CONFIG_FILE = "#{APP_DIR}/user.json"

  class << self
    def new(student, notifier, storage=UqamGradeNotification::Storage.new)
      Client.new(student, notifier, storage)
    end

    def configuration_cli
      unless Dir.exists?(APP_DIR)
        p "Running first time setup."
        Dir.mkdir(APP_DIR)
      end

      cli = HighLine.new
      code = cli.ask("Code Permanent")
      password = cli.ask("NIP")
      phone = cli.ask("Phone Number")
      twilio_account_id = cli.ask("Twilio Account ID")
      twilio_token = cli.ask("Twilio Token")
      twilio_phone = cli.ask("Twilio Phone Number")

      info = { "code" => code,
               "password" => password,
               "phone" => phone,
               "twilio_account_id" => twilio_account_id,
               "twilio_token" => twilio_token,
               "twilio_phone" => twilio_phone
      }

      File.write(CONFIG_FILE, info.to_json)
      info
    end
  end
end
