module UqamGradeNotification
  class Client
    attr_reader :student, :notifier, :storage

    def initialize(student, notifier, storage)
      @student = student
      @notifier = notifier
      @storage = storage
    end

    def notify_of_changes
      if grades_have_changed?
        p "Grades have not changed since last checked."
      else
        message = "Your grades have been updated!"
        p message
        save_student_grades
        notifier.sms(message)
      end
    end

    def grades_have_changed?
      md5 = Digest::MD5.new
      md5.hexdigest(student.grades.to_json) == md5.hexdigest(student_last_grades.to_json)
    end

    def student_last_grades
      @last_grades ||= storage.last_grades(student)
    end

    def save_student_grades
      storage.save_grades(student)
    end
  end
end
