require 'twilio-ruby'

module UqamGradeNotification
  class Notifier
    attr_reader :phone

    def initialize args
      args = HashWithIndifferentAccess.new(args)
      @phone = args.fetch("phone")
      @twilio_account_id = args.fetch("twilio_account_id")
      @twilio_token = args.fetch("twilio_token")
      @twilio_phone = args.fetch("twilio_phone")
    end

    def sms(message)
      client = Twilio::REST::Client.new @twilio_account_id, @twilio_token

      client.account.messages.create({
        from: @twilio_phone,
        to: @phone,
        body: message
      })
    end
  end
end
