module UqamGradeNotification
  class Storage
    extend Forwardable
    def_delegators :@storage, :last_grades, :save_grades

    def initialize(storage=LocalStorage.new)
      @storage = storage
    end

    class LocalStorage
      attr_reader :base_path
      def initialize(base_path=UqamGradeNotification::APP_DIR)
        @base_path = base_path
      end

      def last_grades(student)
        if File.exist?(grade_file(student))
          JSON.parse File.open(grade_file(student), "rb").read
        else
          ""
        end
      end

      def save_grades(student)
        File.write(grade_file(student), student.grades.to_json)
      end

      private

      def grade_file(student)
        "#{base_path}/#{student.code}_grades.json"
      end
    end
  end
end
